from pres.combined.diagrams import *

if __name__ == '__main__':
    imagepath.append( '../images' )
    imagepath.append( 'images' )
    testimage = load_image( imagepath.search( 'mesh.jpg' ) )
else:
    testimage = None

def fit_image( im ):
    if im is None:
        return 1.0, 1.0
    v = visible()
    width = v[2]
    height = v[2] / v[4]
    if width / im.size[0] < height / im.size[1]:
        return width, width * im.size[1] / im.size[0]
    else:
        return height * im.size[0] / im.size[1], height


def focus_image( im = (OBJECT, testimage),
                 center_x = (SCALAR, 0, 1000, 0),
                 center_y = (SCALAR, 0, 1000, 0),
                 zoom = (SCALAR, 0, 4, 0)
                 ):
    if im is None:
        return
    w, h = fit_image( im )
    scale( 2 ** zoom )
    image( (-center_x * w / im.size[0], center_y * h / im.size[1]),
           im, width = w, height = h, anchor = 'nw' )

def pan_image( im = (OBJECT, testimage),
               pan = (SCALAR, 0, 1, 0) ):
    if im is None:
        return
    v = visible()
    win_width = v[2]
    win_height = v[2] / v[4]
    image_width = im.size[0]
    image_height = im.size[1]
    image_aspect = float(image_width)/image_height
    image_width_on_screen = 2*image_aspect
    extra_width = image_width_on_screen - win_width
    translate( -(pan-0.5)*extra_width, 0 )
    image( (0,0), im, height=win_height, anchor='c' )
                     
test_diagrams( pan_image )
