from pres.combined.animations import *
from myfonts import fonts
from math import *

imagepath.append( 'images' )
imagepath.append( '../images' )

import layout
import image_d
import rotation
import cross_out
import bone

FADE_ENTER = 0.25
FADE_EXIT = 0.25
FADE_CROSS = 0.25

def cross_fade( im1, im2 ):
    serial()
    set( im2.alpha, 0.0 )
    lift(im2)
    fade_in( FADE_CROSS, im2 )
    set( im1.alpha, 0.0 )
    end()

def maintitle():
    camera, title, author, affil, bkgd = begin_animation( layout, 'maintitle', 'title', 'author', 'affiliation', 'background' )
    wait( 0.01 )
    pause()
    fade_out( FADE_EXIT, title, author, affil, bkgd )
    return end_animation()

def goal():
    bl = BulletedList( x = 35, y = 75, width = 150,
                       color = black, font = fonts['text'],
                       size = 18.0, leading = 0.25,
                       bullet = (fonts['dingbats'], 'w') )
    bl2 = BulletedList( x = 210, y = 75, width = 150,
                       color = black, font = fonts['text'],
                       size = 18.0, leading = 0.25,
                       bullet = (fonts['dingbats'], 'w') )

    camera, title, cow_im, skel_im, anim1_im, anim2_im, anim3_im, arrow = begin_animation( layout, 'goal', 'title',
                                                                                           'cow_image', 'skel_image',
                                                                                           'anim1_image', 'anim2_image',
                                                                                           'anim3_image', 'arrow' )
    
    enter( bl )
    enter( bl2 )
    make_invisible( title, cow_im, skel_im, anim1_im, anim2_im, anim3_im, arrow )

    fade_in( FADE_ENTER, title, cow_im )
    pause()
    fade_in( FADE_ENTER, skel_im )
    pause()
    fade_in( FADE_ENTER, arrow, anim1_im, anim2_im, anim3_im )
    pause()
    bl.add_item( 0, 'realistic dynamics' )
    pause()
    bl.add_item( 0, 'fast and stable computation' )
    pause()
    bl2.add_item( 0, 'easy to use' )
    pause()
    bl2.add_item( 0, 'arbitrary surface mesh' )
    pause()
    fade_out( FADE_EXIT, title, bl, bl2, cow_im, skel_im, anim1_im, anim2_im, anim3_im, arrow )

    return end_animation()
    
def intro_demo():
    camera,title = begin_animation( layout, 'centered_title', 'title' )
    make_invisible(title)
    set( title.text, 'Demo' )
    fade_in( FADE_ENTER, title )
    pause()
    fade_out( FADE_EXIT, title )
    return end_animation()

def related_work_title():
    camera,title = begin_animation( layout, 'centered_title', 'title' )
    make_invisible(title)
    set( title.text, 'Related Work' )
    fade_in( FADE_ENTER, title )
    pause()
    fade_out( FADE_EXIT, title )
    return end_animation()

fade_color = Color(0.8,0.8,0.8)

def related_work():    
    bl = BulletedList( x = 125, y = 250, width = 350,
                       color = black, font = fonts['text'],
                       size = 18.0, leading = 0.2 )
#                       bullet = (fonts['dingbats'], 'w') )

    
    bl2 = BulletedList( x = 125, y = 250, width = 350,
                        color = fade_color, font = fonts['text'],
                        size = 18.0, leading = 0.2 )
#                        bullet = (fonts['dingbats'], 'w') )

    camera, title, im1, im2, im3, im4 = begin_animation( layout, 'related_work', 'title',
                                                         'image1', 'image2', 'image3', 'image4' )
    enter( bl )
    enter( bl2 )
    make_invisible( title,bl,bl2,im1,im2,im3,im4 )
    fade_in( FADE_ENTER, title,bl )
    pause()

    bl.add_item( 0, 'Free-Form Deformation' )
    bl.add_item( 1, 'Sederberg [1986], MacCracken [1996]' )
    bl.add_item( 1, ' ' )
    fade_in( FADE_ENTER, im1 )
    pause()
    bl.add_item( 0, 'Dynamic Deformation' )
    bl.add_item( 1, 'Terzopoulos [1987]' ) #, Faloutsos [1997]' )
    bl.add_item( 1, ' ' )
    fade_in( FADE_ENTER, im2 )
    pause()
    bl.add_item( 0, 'Skeleton-Driven Deformation' )
    bl.add_item( 1, 'Chadwick [1989]' )
    bl.add_item( 1, 'Scheepers [1997], Wilhelms [1997]' )
    bl.add_item( 1, ' ' )
    fade_in( FADE_ENTER, im3 )
    pause()
    bl.add_item( 0, 'Interactive Dynamic Deformation' )
    bl.add_item( 1, 'Picinbono [2000], Debunne [2001]' )
    bl.add_item( 1, ' ' )
    fade_in( FADE_ENTER, im4 )
    pause()

    bl2.add_item( 0, ['Free-Form ', red, 'Deformation'] )
    bl2.add_item( 1, 'Sederberg [1986], MacCracken [1996]' )
    bl2.add_item( 1, ' ' )
    bl2.add_item( 0, [red,'Dynamic',fade_color,' Deformation'] )
    bl2.add_item( 1, 'Terzopoulos [1987]') #, Faloutsos [1997]' )
    bl2.add_item( 1, ' ' )
    bl2.add_item( 0, [red,'Skeleton-Driven',fade_color,' Deformation'] )
    bl2.add_item( 1, 'Chadwick [1989]' )
    bl2.add_item( 1, 'Scheepers [1997], Wilhelms [1997]' )
    bl2.add_item( 1, ' ' )
    bl2.add_item( 0, [red,'Interactive',fade_color,' Dynamic Deformation'] )
    bl2.add_item( 1, 'Picinbono [2000], Debunne [2001]' )
    bl2.add_item( 1, ' ' )

    parallel()
    fade_out( FADE_CROSS, bl )
    fade_in( FADE_CROSS, bl2 )
    end()
    pause()
    
    fade_out( FADE_EXIT, title, bl2, im1, im2, im3, im4 )
    
    return end_animation()

def overview():
    camera, title, im1, im2 = begin_animation( layout, 'one_image2', 'title',
                                               'image', 'image2' )
    make_invisible( title, im1, im2 )
    set( title.text, "Overview" )
    set( im1.image, load_image( imagepath.search( 'overview1.jpg' ) ) )
    set( im2.image, load_image( imagepath.search( 'overview2.jpg' ) ) )
    fade_in( FADE_ENTER, title )
    pause()
    fade_in( FADE_ENTER, im1 )
    pause()
    cross_fade( im1, im2 )
    pause()
    fade_out( FADE_EXIT, title, im2 )
    return end_animation()    

def elastic_solids():
    camera, title, im1, im2 = begin_animation( layout, 'one_image2', 'title',
                                              'image', 'image2' )

    make_invisible( title, im1, im2 )
        
    set( title.text, "Elastic solids" )
    set( im1.image, load_image( imagepath.search( 'state.jpg' ) ) )
    set( im2.image, load_image( imagepath.search( 'state_r2.jpg' ) ) )
#    set( cap.text, 'What is the dynamic motion?' )

    fade_in(FADE_ENTER,title,im1)
    pause()

    parallel()
    fade_out( FADE_CROSS, title )
    cross_fade( im1, im2 )
    end()
    pause()

    set( im1.image, load_image( imagepath.search( 'state_rp.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()
    
    set( im2.image, load_image( imagepath.search( 'state_rdp.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()
    
    set( im1.image, load_image( imagepath.search( 'state_d.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()

    set( im2.image, load_image( imagepath.search( 'state_d_arrow.jpg' ) ) )
    parallel()
    cross_fade( im1, im2 )
    im2.translate( 0, [0,-20], smooth, 0.5 )
    end()

    fem_im1 = Image( image=load_image( imagepath.search( 'eq_displacement.jpg' ) ),
                     x1 = 50.0,
                     y1 = 175.0,
                     x2 = 350.0,
                     y2 = 235.0,
                     alpha = 0.0 )

    fem_im2 = Image( image=load_image( imagepath.search( 'eq_displacement2.jpg' ) ),
                     x1 = 50.0,
                     y1 = 175.0,
                     x2 = 350.0,
                     y2 = 235.0,
                     alpha = 0.0 )

    set( title.text, "Finite element method" )
    
    enter( fem_im1 )
    parallel()
    fade_in( FADE_ENTER, title )
    fade_in( FADE_ENTER, fem_im1 )
    end()
    pause()

    enter( fem_im2 )
    fade_in( FADE_ENTER, fem_im2 )
    exit( fem_im1 )
    pause()

    fade_out(FADE_EXIT,im2,fem_im2,title)
    
    return end_animation()
                                                                     
#def fem_design_space():
#    bl = BulletedList( x = 25, y = 250, width = 350,
#                       color = black, font = fonts['text'],
#                       size = 20.0, bullet = (fonts['dingbats'], 'w') )
#    
#    camera, title = begin_animation( layout, 'title_only', 'title' )
#    enter( bl )
#    make_invisible( bl, title )
#    set( title.text, "FEM Design Space" )

#    bl.add_item( 0, 'choices' )
#    fade_in( 0.5, title, bl )
#    pause()
#    bl.add_item( 1, 'grid' )
#    pause()
#    bl.add_item( 1, 'basis functions' )
#    pause()
#    bl.add_item( 0, 'needs' )
#    pause()
#    bl.add_item( 1, 'fast' )
#    pause()
#    bl.add_item( 1, 'easy' )
#    pause()
#    bl.add_item( 1, 'adaptive' )
#    pause()
#    bl.add_item( 1, 'skeleton' )
#    pause()
#    fade_out( 0.5, title, bl )

#    return end_animation()

def basis():
    camera, title, im1, im2 = begin_animation( layout, 'one_image2', 'title', 'image', 'image2' )
    make_invisible( title, im1, im2 )
    
    set( title.text, 'Basis functions' )

    set( im1.image, load_image( imagepath.search( 'object.jpg' ) ) )
    set( im2.image, load_image( imagepath.search( 'nonregular_embedding.jpg' ) ) )

    fade_in( FADE_ENTER, im1, title )
    pause()

    parallel()
    fade_out( FADE_EXIT, title )
    cross_fade( im1, im2 )
    end()
    pause()
        
    set( im1.image, load_image( imagepath.search( 'nonregular_basis_function.jpg' ) ) )
    phi_im = Image( image=load_image( imagepath.search( 'phi.jpg' ) ), x1=300, y1=150, x2=380, y2=230, alpha=0.0 )
    enter(phi_im)
    set( im1.alpha, 0.0 )
    lift(im1)
    lift(phi_im)
    parallel()
    fade_in( FADE_CROSS, im1 )
    fade_in( FADE_CROSS, phi_im )
    end()
    set( im2.alpha, 0.0 )
    pause()

    fade_out( FADE_EXIT, phi_im )

    set( im2.image, load_image( imagepath.search( 'nonregular_basis_function_with_dot.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()

    set( im1.image, load_image( imagepath.search( 'nonregular_coarse_basis.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()

    set( im2.image, load_image( imagepath.search( 'nonregular_both_basis.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()
    
    set( im1.image, load_image( imagepath.search( 'nonregular_unrestricted.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()

    set( im2.image, load_image( imagepath.search( 'nonregular_restricted.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()
    
    fade_out( FADE_EXIT, im2, title )
        
    return end_animation()

def euler_lagrange():
    camera, title, im1, im2 = begin_animation( layout, 'one_image2', 'title',
                                               'image', 'image2' )
    make_invisible( title, im1, im2 )
    set( title.text, 'Euler-Lagrange equations' )
    set( im1.image, load_image( imagepath.search( 'eq_euler.jpg' ) ) )
    set( im2.image, load_image( imagepath.search( 'eq_euler_t.jpg' ) ) )

    fade_in( FADE_ENTER, title, im1 )
    pause()
    cross_fade( im1, im2 )
    pause()
    set( im1.image, load_image( imagepath.search( 'eq_euler_u.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()
    set( im2.image, load_image( imagepath.search( 'eq_euler_f.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()
    fade_out( FADE_EXIT, title, im2 )

    return end_animation()

def kinetic_energy():
    camera, title, im, cap1, cap2, label = begin_animation( layout, 'potential_energy', 'title', 'image',
                                                            'caption', 'caption2', 'pe_label' )
    make_invisible( title, im, cap1, cap2, label )
    set( title.text, "Kinetic energy" )
    set( im.image, load_image( imagepath.search( 'state_ke.jpg' ) ) )
    set( cap1.image, load_image( imagepath.search( 'ke.jpg' ) ) )
    set( cap2.image, load_image( imagepath.search( 'ke2.jpg' ) ) )
    fade_in( FADE_ENTER, title, im )
    pause()
    fade_in( FADE_ENTER, cap1 )
    pause()
    cross_fade( cap1, cap2 )
    pause()
    set( cap1.image, load_image( imagepath.search( 'ke3.jpg' ) ) )
    cross_fade( cap2, cap1 )
    pause()

    fade_out( FADE_EXIT, title, im, cap1 )
    return end_animation()

def potential_energy():
    camera, title, im, cap1, cap2, label = begin_animation( layout, 'potential_energy', 'title', 'image',
                                                            'caption', 'caption2', 'pe_label' )
    make_invisible( title, im, cap1, cap2, label )
    set( title.text, "Elastic potential energy" )
    set( im.image, load_image( imagepath.search( 'deformed_box.jpg' ) ) )
    set( cap1.image, load_image( imagepath.search( 'eq_strain.jpg' ) ) )
    set( cap2.image, load_image( imagepath.search( 'pe.jpg' ) ) )
    fade_in( FADE_ENTER, title, im )
    pause()
    fade_in( FADE_ENTER, cap1, label )
    pause()
    parallel()
    fade_out( FADE_CROSS, label )
    cross_fade( cap1, cap2 )
    end()
    pause()
    set( cap1.image, load_image( imagepath.search( 'pe5.jpg' ) ) )
    cross_fade( cap2, cap1 )
    pause()
    set( cap2.image, load_image( imagepath.search( 'pe3.jpg' ) ) )
    cross_fade( cap1, cap2 )
    pause()
    set( cap1.image, load_image( imagepath.search( 'pe4.jpg' ) ) )
    cross_fade( cap2, cap1 )
    pause()
    set( cap2.image, load_image( imagepath.search( 'pe2.jpg' ) ) )
    cross_fade( cap1, cap2 )
    pause()

    fade_out( FADE_EXIT, title, im, cap2 )
    return end_animation()

def odes():
    camera, title, im = begin_animation( layout, 'one_image', 'title', 'image' )
    make_invisible( title, im )
    set( title.text, "System of ODEs" )
    set( im.image, load_image( imagepath.search( 'eq_euler.jpg' ) ) )
    fade_in( FADE_ENTER, title, im )
    pause()
    fade_out( FADE_EXIT, im )
    set( im.image, load_image( imagepath.search( 'eq_euler2.jpg' ) ) )
    fade_in( FADE_ENTER, im )
    pause()
    fade_out( FADE_EXIT, im )
    set( im.image, load_image( imagepath.search( 'eq_euler3.jpg' ) ) )
    fade_in( FADE_ENTER, im )
    pause()
    fade_out( FADE_EXIT, im )
    set( im.image, load_image( imagepath.search( 'ode1.jpg' ) ) )
    fade_in( FADE_ENTER, im )
    pause()

    fade_out( FADE_EXIT, title, im )
    return end_animation()

def part1():
    camera,title,title2 = begin_animation( layout, 'centered_title2', 'title', 'title2' )
    make_invisible(title, title2)
    set( title.text, 'Interactive Skeleton-Driven\nDynamic Deformations' )
    set( title2.text, [fade_color,'Interactive Skeleton-Driven\n', red, 'Dynamic Deformations'] )
    fade_in( FADE_ENTER, title )
    pause()
    cross_fade( title, title2 )
    pause()
    fade_out( FADE_EXIT, title2 )
    return end_animation()

def part2():
    camera,title,title2 = begin_animation( layout, 'centered_title2', 'title', 'title2' )
    make_invisible(title, title2)
    set( title.text, 'Interactive Skeleton-Driven\nDynamic Deformations' )
    set( title2.text, [red,'Interactive Skeleton-Driven\n', fade_color, 'Dynamic Deformations'] )
    fade_in( FADE_ENTER, title )
    pause()
    cross_fade( title, title2 )
    pause()
    fade_out( FADE_EXIT, title2 )
    return end_animation()

def skeletal_constraints():
    bl = BulletedList( x = 100, y = 75, width = 350,
                       color = black, font = fonts['text'],
                       size = 18.0, leading = 0.2 )
    bl2 = BulletedList( x = 100, y = 75, width = 350,
                        color = black, font = fonts['text'],
                        size = 18.0, leading = 0.2 )
    
    camera, title, im1, im2 = begin_animation( layout, 'one_image2', 'title', 'image', 'image2' )
    set( im1.x1, 25 )
    set( im1.x2, 375 )
    set( im1.y1, 75 )
    set( im1.y2, 250 )
    set( im2.x1, 25 )
    set( im2.x2, 375 )
    set( im2.y1, 75 )
    set( im2.y2, 250 )
    enter(bl,bl2)
    make_invisible( title, im1, im2 )
    set( title.text, "Skeletal Constraints" )
    set( im1.image, load_image( imagepath.search( 'nonregular_embedding.jpg' ) ) )
    set( im2.image, load_image( imagepath.search( 'nonregular_skel.jpg' ) ) )
    fade_in( FADE_ENTER, title, im1 )
    pause()

    cross_fade( im1, im2 )
    pause()
    set( im1.image, load_image( imagepath.search( 'nonregular_skel2.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()

    bl.add_item( 0, 'Expensive:' )
    bl.add_item( 1, ' - compute all dofs' )
    bl.add_item( 1, ' - meet constraints' )
    pause()
    fade_out( FADE_EXIT, bl )
    set( im2.image, load_image( imagepath.search( 'nonregular_skel_aligned.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()
    bl2.add_item( 0, 'Solution:' )
    bl2.add_item( 1, ' - align skeleton with grid' )
    bl2.add_item( 1, ' - use interpolating trilinear basis' )
    pause()
    fade_out( FADE_EXIT, im2, title, bl2 )
    return end_animation()

def instrumentation():
    camera, title, im1, im2, im3 = begin_animation( layout, 'instrumentation', 'title', 'left', 'middle', 'right' )
    make_invisible( title, im1, im2, im3 )
    fade_in( FADE_ENTER, title, im1 )
    pause()
    fade_in( FADE_ENTER, title, im2 )
    pause()
    fade_in( FADE_ENTER, title, im3 )
    pause()
    fade_out( FADE_EXIT, title, im1, im2, im3 )
    return end_animation()

def linearization():
    camera, title, strain_im, d, ode_im, ode_label, implicit_label, linear_system, strain_label = begin_animation( layout,
                                                                                                                  'linear_strain',
                                                                                                                  'title',
                                                                                                                  'strain_image',
                                                                                                                  'cross',
                                                                                                                  'ode_image',
                                                                                                                  'ode_label',
                                                                                                                  'implicit_label',
                                                                                                                  'linear_system',
                                                                                                                  'strain_label',
                                                                                                                  cross = cross_out.cross_out )
    make_invisible( title, strain_im, d, ode_im, ode_label, implicit_label, linear_system, strain_label )
    set( d.second_stroke, 0.0 )
    fade_in( FADE_ENTER, title, strain_im, strain_label, ode_label, ode_im )
    pause()
    fade_in( 0.0, d )
    wait(0.25)
    set( d.second_stroke, 1 )
    wait(0.01)
    pause()
    fade_out( FADE_EXIT, ode_im )
    set( ode_im.image, load_image( imagepath.search( 'ode2.jpg' ) ) )
    fade_in( FADE_ENTER, ode_im )
    pause()
    fade_in( FADE_ENTER, implicit_label, linear_system )
    pause()
    fade_out( FADE_EXIT, title, strain_im, d, ode_im, ode_label, implicit_label, linear_system, strain_label )
    return end_animation()

def linearization_video():
    camera, title = begin_animation( layout, 'title_only', 'title' )
    set( title.text, "Linear strain results" )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    return end_animation()

def linear_compare():
    camera, left,right,left_cap,right_cap = begin_animation( layout, 'cow_compare1', 'left','right',
                                                             'left_text','right_text' )
    make_invisible( left,right,left_cap,right_cap )
    fade_in( FADE_ENTER, left,right,left_cap,right_cap)
    pause()
    fade_out( FADE_ENTER, left,right,left_cap,right_cap)
    return end_animation()

def rotation_and_strain():
    camera, title, d, cap = begin_animation( layout, 'rotation', 'title',
                                             'diagram', 'caption', diagram = rotation.blocks )
    make_invisible( title, d, cap )
    set( title.text, 'Strain and rotation' )
    max_angle = 1.0
    max_deform = 0.13
    set( d.zoom, 0.28 ) # was 2.1
    fade_in( FADE_ENTER, title, d )
    pause()
    parallel()
    smooth( 1.0, d.angle, max_angle )
    smooth( 1.0, d.deform, max_deform )
    end()
    parallel()
    smooth( 1.0, d.angle, -max_angle )
    smooth( 1.0, d.deform, -max_deform )
    end()
    parallel()
    smooth( 1.0, d.angle, max_angle )
    smooth( 1.0, d.deform, max_deform )
    end()
    pause()
    smooth( 0.5, d.show_displacement, 1.0 )
    pause()
    parallel()
    smooth( 1.0, d.angle, -max_angle )
    smooth( 1.0, d.deform, -max_deform )
    end()
    parallel()
    smooth( 1.0, d.angle, max_angle )
    smooth( 1.0, d.deform, max_deform )
    end()
    pause()
    parallel()
    smooth( 1.0, d.angle, 0.0 )
    smooth( 1.0, d.deform, 0.0 )
    end()
    pause()
    parallel()
#    smooth( 1.0, d.zoom, 1.5 )
    smooth( 1.0, d.vgap, 1.0 )
    smooth( 1.0, d.gap, 1.0 )
    end()
    smooth( 1.0, d.use_rotated, 1.0 )
    pause()
    parallel()
    smooth( 1.0, d.angle, max_angle )
    smooth( 1.0, d.deform, max_deform )
    end()
    parallel()
    smooth( 1.0, d.angle, -max_angle )
    smooth( 1.0, d.deform, -max_deform )
    end()
    parallel()
    smooth( 1.0, d.angle, max_angle )
    smooth( 1.0, d.deform, max_deform )
    end()
    pause()
    parallel()
    smooth( 1.0, d.angle, 0 )
    smooth( 1.0, d.deform, 0 )
    end()    
    set( cap.text, 'What is a suitable rotation?' )
    fade_in( FADE_ENTER, cap )
    pause()
    fade_out( FADE_EXIT, cap )
    set( cap.text, '"rigid body" - Terzopoulos and Witkin 1988' )
    fade_in( FADE_ENTER, cap )
    pause()
    fade_out( FADE_EXIT, cap )
    set( cap.text, 'Bone constraints provide a suitable rotation!' )
    fade_in( FADE_ENTER, cap )
    pause()
    parallel()
    smooth( 0.5, d.show_bone, 1.0 )
    fade_out( 0.5, cap )
    end()
    pause()

    parallel()
    smooth( 1.0, d.angle, max_angle )
    smooth( 1.0, d.deform, max_deform )
    end()
    parallel()
    smooth( 1.0, d.angle, -max_angle )
    smooth( 1.0, d.deform, -max_deform )
    end()
    parallel()
    smooth( 1.0, d.angle, max_angle )
    smooth( 1.0, d.deform, max_deform )
    end()
    pause()

    smooth( 1.0, d.circle_displacement, 1.0 )
    pause()
    
    fade_out( FADE_EXIT, d, title )

    return end_animation()

def rotation_and_strain2():
    camera, title, d, cap = begin_animation( layout, 'rotation', 'title',
                                             'diagram', 'caption', diagram = rotation.block2 )
    make_invisible( title, d, cap )
    set( title.text, 'Strain and rotation' )
    set( cap.text, u'Terzopoulos [1988], Capell [2002], M\u00fcller [2002]' )
    max_final_angle = 1.0
    max_rest_angle = 4.0*pi
    max_deform = 0.13
    set( d.zoom, 0.36 ) # was 2.8
    set( d.tuck, 1.0 )

    set( d.final_angle, max_final_angle )
    set( d.deform, max_deform )
    fade_in( FADE_ENTER, title, d )
    pause()
    smooth( 1.0, d.tuck, 0.0 )
    smooth( 1.0, d.show_displacement, 1.0 )
    pause()
    smooth( 1.0, d.rest_angle, 0.5*max_final_angle )
    pause()
    smooth( 2.0, d.rest_angle, 2.0*max_final_angle )
    pause()
    smooth( 1.0, d.rest_angle, max_final_angle )
    pause()
    fade_in( FADE_ENTER, cap )
    pause()
    fade_out( FADE_EXIT, cap )
    pause()

    smooth( 0.5, d.show_bone, 1.0 )
    pause()
    
    fade_out( FADE_EXIT, d, title )

    return end_animation()

def blended_linear():
    camera, title, im1,im2 = begin_animation( layout, 'one_image2', 'title', 'image','image2' )
    set( title.text, "Blended linear elasticity" )

    make_invisible( title, im1,im2 )
    set( im1.image, load_image( imagepath.search( 'regions1.jpg' ) ) )
    set( im2.image, load_image( imagepath.search( 'regions2.jpg' ) ) )
    fade_in( FADE_ENTER, title, im1 )
    pause()

    cross_fade( im1, im2 )
    pause()
    
    set( im1.image, load_image( imagepath.search( 'regions3.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()
    
    set( im2.image, load_image( imagepath.search( 'regions4.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()

    set( im1.image, load_image( imagepath.search( 'blended_linear.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()

    fade_out( FADE_EXIT, im1, title )    
    
    return end_animation()    

def blended_video():
    camera, title = begin_animation( layout, 'title_only', 'title' )
    set( title.text, "Blended linear results" )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    return end_animation()

def blended_compare():
    camera, left,right,bot,left_cap,right_cap,bot_cap = begin_animation( layout, 'cow_compare2', 'left','right',
                                                                         'bottom', 'left_text','right_text',
                                                                         'bottom_text' )
    make_invisible( left,right,left_cap,right_cap,bot,bot_cap )
    fade_in( FADE_ENTER, left,right,left_cap,right_cap,bot,bot_cap)
    pause()
    fade_out( FADE_EXIT, left,right,left_cap,right_cap,bot,bot_cap)
    return end_animation()

def bad_twist_video():
    camera, title = begin_animation( layout, 'title_only', 'title' )
    set( title.text, 'Twisting trouble' )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    return end_animation()

ROTATION_SPEED = 2.0

def bones():
    camera, title, d, im1, im2 = begin_animation( layout, 'bone_twist', 'title', 'diagram',
                                                  'caption_image', 'caption_image2',
                                                  diagram = bone.bone )
    make_invisible( title, d, im1, im2 )
    set( title.text, 'Twisting trouble' )
    set( im1.image, load_image( imagepath.search( 'bone_constraint.jpg' ) ) )
    set( im2.image, load_image( imagepath.search( 'bone_constraint2.jpg' ) ) )
    fade_in( FADE_ENTER, title, d )
    pause()
    smooth( ROTATION_SPEED, d.outer_angle, -45 )
    smooth( ROTATION_SPEED, d.outer_angle, 45 )
    smooth( ROTATION_SPEED, d.outer_angle, -45 )
    pause()
    smooth( ROTATION_SPEED, d.bone_radius, 0.0 )
    smooth( ROTATION_SPEED, d.outer_angle, 45 )
    smooth( ROTATION_SPEED, d.outer_angle, -45 )
    smooth( ROTATION_SPEED, d.outer_angle, 0 )
    pause()
    parallel()
    smooth( FADE_ENTER, d.pe_region, 0.8 )
    smooth( FADE_ENTER, d.show_b, 1.0 )
    end()
    pause()
    fade_in( FADE_ENTER, im1 )
    pause()
    cross_fade( im1, im2 )
    pause()
    set( im1.image, load_image( imagepath.search( 'bone_constraint3.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()
    set( im2.image, load_image( imagepath.search( 'bone_constraint4.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()
    set( d.outer_angle, 0 )
    set( d.inner_angle, 0 )
    set( d.bone_radius, 0.375 )
    set( d.show_bone, 0 )
    set( d.rings, 1 )
#    smooth( 2.0, d.bone_radius, 0.25 )
#    pause()
    smooth( FADE_EXIT, d.show_b, 0.0 )
    parallel()
    smooth( ROTATION_SPEED, d.outer_angle, -45 )
    smooth( ROTATION_SPEED, d.inner_angle, -10 )
    end()
    parallel()
    smooth( ROTATION_SPEED, d.outer_angle, 45 )
    smooth( ROTATION_SPEED, d.inner_angle, 10 )
    end()
    parallel()
    smooth( ROTATION_SPEED, d.outer_angle, -45 )
    smooth( ROTATION_SPEED, d.inner_angle, -10 )
    end()
    parallel()
    smooth( ROTATION_SPEED, d.outer_angle, 45 )
    smooth( ROTATION_SPEED, d.inner_angle, 10 )
    end()
    parallel()
    smooth( ROTATION_SPEED, d.outer_angle, -45 )
    smooth( ROTATION_SPEED, d.inner_angle, -10 )
    end()
    pause()
    fade_out( FADE_EXIT, title, d, im2 )
    
    return end_animation()

def good_twist_video():
    camera, title = begin_animation( layout, 'title_only', 'title' )
    set( title.text, 'Twisting remedied' )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    return end_animation()

def constraints():
    camera, title, im1, im2, im3, cap, lin_sys_im, lin_sys_label, eq_label, eq_im, eq2, eq3, eq4 = begin_animation( layout,
                                                                                                          'cg',
                                                                                                          'title',
                                                                                                          'im1',
                                                                                                          'im2',
                                                                                                          'im3',
                                                                                                          'caption',
                                                                                                          'linear_system_image',
                                                                                                          'linear_system_label',
                                                                                                          'eq1_label',
                                                                                                          'eq1_image',
                                                                                                          'eq3',
                                                                                                          'eq4',
                                                                                                          'eq5' )
    make_invisible( title, im1, im2, im3, cap, lin_sys_im, lin_sys_label, eq_label, eq_im, eq2, eq3, eq4 )
    set( cap.text, "generalization of [Baraff and Witkin 1999]" )
    set( im2.image, load_image( imagepath.search( 'cg1.jpg' ) ) )
    fade_in( FADE_ENTER, title, lin_sys_im, lin_sys_label )
    pause()

    fade_in( FADE_ENTER, im1 )
    pause()

    cross_fade( im1, im2 )
    pause()
    
    fade_in( FADE_ENTER, im3)
    pause()

    fade_in( FADE_ENTER, eq_im, eq_label )
    pause()

    fade_out( FADE_EXIT, eq_im )
    set( eq_im.image, load_image( imagepath.search( 'constraint_eq2.jpg' ) ) )
    fade_in( FADE_ENTER, eq_im )
    pause()

    fade_in( FADE_ENTER, eq2 )
    pause()
    fade_in( FADE_ENTER, eq3 )
    pause()
    fade_in( FADE_ENTER, eq4 )
    pause()
        
    set( im1.image, load_image( imagepath.search( 'cg2.jpg' ) ) )
    cross_fade( im2, im1 )
    pause()
    
    set( im2.image, load_image( imagepath.search( 'cg3.jpg' ) ) )
    cross_fade( im1, im2 )
    pause()

    fade_in( FADE_ENTER, cap )
    pause()
    
    fade_out( FADE_EXIT, title, im2, im3, cap, lin_sys_im, lin_sys_label, eq_label, eq_im,eq2,eq3,eq4 )
    
    return end_animation()

def constraints_video():
    camera, title = begin_animation( layout, 'title_only', 'title' )
    set( title.text, "Position constraints" )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    return end_animation()
 
def adaptation_video():
    camera, title = begin_animation( layout, 'title_only', 'title' )
    set( title.text, "Adaptation" )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    return end_animation()
    
def final_demo():
    camera, title = begin_animation( layout, 'centered_title', 'title' )
    set( title.text, "Demo" )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    pause()
    fade_out( FADE_EXIT, title )
    return end_animation()

def contributions():
    bl = BulletedList( x = 25, y = 225, width = 350,
                       color = black, font = fonts['text'],
                       size = 20.0, bullet = (fonts['dingbats'], 'w') )
    
    camera, title = begin_animation( layout, 'title_only', 'title' )
    enter( bl )
    make_invisible( bl, title )
    set( title.text, "Contributions" )
    fade_in( FADE_ENTER, title, bl )
    pause()
    bl.add_item( 0, "interactive character animation with realistic secondary deformation" )
    pause()
    bl.add_item( 1, 'fast and easy skeletal constraints' )
    pause()
    bl.add_item( 1, 'bone-relative linearization' )
    pause()
    bl.add_item( 1, 'twist penalty for 1D bones' )
    pause()
    bl.add_item( 1, 'fast position constraints using linear subspace projection' )
    pause()
    fade_out( FADE_EXIT, title, bl )
    return end_animation()

def future_work_title():
    camera, title = begin_animation( layout, 'centered_title', 'title' )
    set( title.text, "Future Work" )
    make_invisible( title )
    fade_in( FADE_ENTER, title )
    pause()
    fade_out( FADE_EXIT, title )
    return end_animation()

def future_work():   
    camera, title, im = begin_animation( layout, 'future_work', 'title', 'image' )
    make_invisible( title, im )
    set( title.text, "Powerful tools for skeleton\nand lattice construction" )
    set( im.image, load_image( imagepath.search( 'instrumentation.jpg' ) ) )
    fade_in( FADE_ENTER, title, im )
    pause()
    fade_out( FADE_EXIT, title, im )
    set( title.text, 'Skeletal response to\nexternal forces' )
    set( im.image, load_image( imagepath.search( 'cow_nose.jpg' ) ) )
    fade_in( FADE_ENTER, title, im )
    pause()
    fade_out( FADE_EXIT, title, im )
    set( title.text, 'Better control mechanisms' )
    set( im.image, load_image( imagepath.search( 'cow_smile.jpg' ) ) )
    fade_in( FADE_ENTER, title, im )
    pause()
    fade_out( FADE_EXIT, title, im )

    return end_animation()

def acknowledgements():
    camera, title, people = begin_animation( layout, 'acks', 'title', 'people' )
    make_invisible( title, people )
    fade_in( FADE_ENTER, title, people )
    pause()
    fade_out( FADE_EXIT, title, people )
    return end_animation()

test_animations( bones )
